package uy.edu.fing.tse.central.db.dao.state;

import uy.edu.fing.tse.central.db.entity.Estado;
import uy.edu.fing.tse.central.db.mapper.MyMapper;
import uy.edu.fing.tse.dto.State;

import javax.annotation.PostConstruct;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import java.util.List;
import java.util.stream.Collectors;

@Stateless
public class StateDAOBean implements StateDaoLocal {

    @PersistenceContext(unitName = "central")
    private EntityManager em;

    @PostConstruct
    void init() {
        //Despues del constructor hace esto
    }

    @Override
    public void create(State elem) {
        final var r = MyMapper.INSTANCE.convert(elem);
        em.persist(r);
        em.flush();
    }

    @Override
    public State find(String key) {
        final var query = em.createNamedQuery("Estado.findByValue", Estado.class);
        query.setParameter("val", key);
        final var r = query.getSingleResult();
        return MyMapper.INSTANCE.convert(r);
    }

    @Override
    public State find(Long id) {
        final var e = em.find(Estado.class, id);
        return MyMapper.INSTANCE.convert(e);
    }

    @Override
    public List<State> findAll() {
        final var query = em.createNamedQuery("Estado.findAll", Estado.class);
        final List<Estado> r = query.getResultList();
        return r.stream().map(MyMapper.INSTANCE::convert).collect(Collectors.toList());
    }
}
