package uy.edu.fing.tse.central.business;


import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import uy.edu.fing.tse.central.db.dao.fact.FactDaoLocal;
import uy.edu.fing.tse.central.db.dao.role.RoleDaoLocal;
import uy.edu.fing.tse.central.db.dao.score.ScoreDaoLocal;
import uy.edu.fing.tse.central.db.dao.state.StateDaoLocal;
import uy.edu.fing.tse.central.db.dao.user.UserDaoLocal;
import uy.edu.fing.tse.dto.*;

import javax.annotation.PostConstruct;
import javax.ejb.EJB;
import javax.ejb.Stateless;
import java.util.List;

@Stateless
public class BusinessBean implements BusinessLocal, BusinessRemote {

    private static final long serialVersionUID = 4079626203846038482L;
    private static final Logger LOG = LoggerFactory.getLogger(Business.class);

    @EJB
    private FactDaoLocal hechos;
    @EJB
    private UserDaoLocal usuarios;
    @EJB
    private StateDaoLocal estados;
    @EJB
    private RoleDaoLocal roles;
    @EJB
    private ScoreDaoLocal calificacion;

    @PostConstruct
    void init() {
        //Despues Hace esto
    }

    @Override
    public void altaPeriferico(Peripherical p) {

    }

    @Override
    public void altaVerificacionMecanismo(CheckMechanism cm) {

    }

    @Override
    public List<Fact> listarHechos() {
        return hechos.findAll();
    }

    @Override
    public void altaHecho(Fact fact) {
        hechos.create(fact);
    }


    @Override
    public void altaEstado(State state) {
        estados.create(state);
    }

    @Override
    public void altaRol(Role role) {
        roles.create(role);
    }

    @Override
    public List<Role> listarRoles() {
        return roles.findAll();
    }

    @Override
    public void altaCalificacion(Score e) {
        calificacion.create(e);
    }

}
