package uy.edu.fing.tse.central.business.common;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Consumer;

public final class Notifier {

    public static Map<String, List<Consumer<String>>> actions = new HashMap<>();

    private static List<Consumer<String>> getActionsByName(final String name) {
        return actions.getOrDefault(name, new ArrayList<>());
    }

    public static void subscribe(final String name, final Consumer<String> c) {
        final var actionsByName = getActionsByName(name);
        actionsByName.add(c);
        actions.put(name, actionsByName);
    }

    public static void notify(final String name, final String msg) {
        for (Consumer<String> callable : getActionsByName(name)) {
            callable.accept(msg);
        }
    }

}
